<?php

/**
 * Project:     Collator Backup: the Question Writer results backup
 * File:        config.php
 *
 * Copyright 2008-2009 Central Question Ltd.
 * 
 * This application is provided as an extension of the 
 * Question Writer desktop software. Where you hold a valid, paid-for
 * license for the Question Writer desktop software, you are hereby 
 * granted a license to use and modify this application for personal use
 * and use internal to your organization. All other rights are reserved. 
 * 
 * This application is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * @link http://www.questionwriter.com/
 * @copyright 2008-2009 Central Question Ltd.
 * @author Alexander McCabe 
 * @package Collator Backup
 * @version 1.0
 */

	//Include the files this script depends upon
	include "config.php";
	include "include/functions.inc.php";

	//Get the IP address of the result set sender
	$ipvar=$_SERVER['REMOTE_ADDR'];
	
	//Trim the e-mail to ignore leading and trailing whitespace.
	$emailID=trim($_GET['email']);
	$userid=trim($_GET['id']);
	
	//Ensure that the e-mail is a real email address.
	//This also returns an error if there are any disallowed characters in the email address
	if(!isValidEmail($emailID) && $userid=="") 
	{
		//Otherwise return an error to the client		
		returnError("Invalid E-mail Address");
	}

	//Set the timestamp
	$newTime=time();
		
	$HTTP_RAW_POST_DATA="";
	
	//Check there is a valid XML file in the POST request
	if($xml = getPostedXML())
	{
		if (!($xmlparser = xml_parser_create()) ) {
			returnError("Cannot create parser");
		}
		if (!xml_parse($xmlparser, $xml)) {
			$reason = xml_error_string(xml_get_error_code($xmlparser));
			$reason .= xml_get_current_line_number($xmlparser);
			returnError("Error - did not find suitable XML " . $reason);
		}
	}
	else
	{		
	  //If XML is not found, return error.
	  returnError("Error - did not find suitable XML " . $xml);	  
	}
	
	//Write time, xml, ip address, email address, id to database to process later
	
	//Open the database connection
	mysql_connect($dbhost,$dbusername,$dbuserpass) or returnError("Error - could not connect to database");
	//Choose the database
	@mysql_select_db($db_name) or returnError("Error - unable to select database");
	
	//Update database with results record
	$query = "INSERT INTO resultbackup "
		. '(email'
		. ',id'
		. ',xml'
		. ',ip'
		. ',timestamp'
		. ') VALUES '
		. "('" . mysql_real_escape_string($emailID)
		. "','" . mysql_real_escape_string($userid)
		. "','" . mysql_real_escape_string($xml)
		. "','" . mysql_real_escape_string($ipvar)
		. "','" . mysql_real_escape_string($newTime)
		. "')";
		
	$result = mysql_query($query) or returnError("Error - could not add resultset to backup database");
	
	//Return suitable non-error to client
	header('Content-Type: text/xml; Charset: utf-8');
	print("<OK/>");
	//End of script
?>